From: Shengjing Zhu <zhsj@debian.org>
Date: Sun, 30 Jul 2023 18:56:43 +0800
Subject: Adapt golang-github-pierrec-lz4 v4

Forwarded: https://github.com/hashicorp/packer/pull/12546
---
 post-processor/compress/post-processor.go | 23 +++++++++++++++++++++--
 1 file changed, 21 insertions(+), 2 deletions(-)

diff --git a/post-processor/compress/post-processor.go b/post-processor/compress/post-processor.go
index c4edbfe..51ebffe 100644
--- a/post-processor/compress/post-processor.go
+++ b/post-processor/compress/post-processor.go
@@ -306,8 +306,27 @@ func makeBGZFWriter(output io.WriteCloser, compressionLevel int) (io.WriteCloser
 
 func makeLZ4Writer(output io.WriteCloser, compressionLevel int) (io.WriteCloser, error) {
 	lzwriter := lz4.NewWriter(output)
-	if compressionLevel > 0 {
-		lzwriter.Header.CompressionLevel = compressionLevel
+	if compressionLevel < 0 {
+		return lzwriter, nil
+	}
+	levels := map[int]lz4.CompressionLevel{
+		0: lz4.Fast,
+		1: lz4.Level1,
+		2: lz4.Level2,
+		3: lz4.Level3,
+		4: lz4.Level4,
+		5: lz4.Level5,
+		6: lz4.Level6,
+		7: lz4.Level7,
+		8: lz4.Level8,
+		9: lz4.Level9,
+	}
+	level, ok := levels[compressionLevel]
+	if !ok {
+		return nil, ErrInvalidCompressionLevel
+	}
+	if err := lzwriter.Apply(lz4.CompressionLevelOption(level)); err != nil {
+		return nil, err
 	}
 	return lzwriter, nil
 }
